#include <stdlib.h>
#include <stdio.h>
#include "basic.h"

typedef struct {
  unsigned int nprocs ;
  volatile unsigned int count ;
  volatile int sense ;
} barrier_t ; 


barrier_t *alloc_my_barrier(unsigned int nprocs) {
  barrier_t *p = malloc_check(sizeof(*p)) ;
  p->nprocs = p->count = nprocs ;
  p->sense = 0 ;
  return p ;
}

void free_my_barrier(barrier_t *p) {
  free(p) ;
}

/* Coded in C */

void wait_my_barrier(barrier_t *p, int *mySense) {
  SYNC() ;
  int sense = *mySense ;
  int rem = DECR(&p->count) ;
  SYNC() ;
  if (rem == 0) {
    p->count = p->nprocs ;
    SYNC() ;
    p->sense = !sense ;
  } else {
    unsigned int c = 0 ;
    while (p->sense == sense) {
      if (++c == 8000000U) { c = 0 ; printf("+") ; fflush(stdout) ; } }
  }
  SYNC() ;
  *mySense = !sense ;
}

