#include <pthread.h>

/*  Nodes */

void flush_free_list(void) ;

typedef struct stack_node_t {  
  void *val ;
  struct stack_node_t *next ;
} stack_node_t ;

/* List of nodes, with count */
typedef struct free_list_t {
  stack_node_t *p ;
  int count ;
} free_list_t ;

/* Stack proper */
typedef struct {
  stack_node_t *top ;
  int nprocs ;
  stack_node_t **hazard ;    /* Hazard pointers */
  free_list_t *retired ;        /* retired nodes */
  pthread_mutex_t *mutex ;
} stack_t ;

stack_t *alloc_stack(int nprocs) ;
void free_stack(stack_t *p) ;

void push(stack_t *p, void *v) ;
void *pop(stack_t *p,int id) ;

inline static void init_heap(void) { } ;
