#include <stdlib.h>
#include <stdio.h>
#include "basic.h"
#include "fifo.h"

static int verbose = 0 ;



/* Barrier */

#include "sense_barrier.c"

typedef struct {
  int m ;
  barrier_t *b ;
} common_t ;

typedef struct {
  int id ;
  common_t *common ;
} ctx_t ;

void *runner(void *_p) {
  ctx_t *p = _p ; common_t *q = p->common ;
  int sense = 0 ;
  for (int k = 0 ; k < q->m ; k++) {
    wait_my_barrier(q->b,&sense) ;
    printf("<%i>",p->id) ; fflush(stdout) ;
    wait_my_barrier(q->b,&sense) ;
    if (p->id == 0)  printf("\n") ;
  }
  return NULL ;
}

void run(int n, int m) {
  common_t c ;
  c.b = alloc_my_barrier(n) ;
  c.m = m ;
  pthread_t th[n] ; ctx_t a[n] ;
  for (int k = 0 ; k < n ; k++) {
    ctx_t *p = &a[k] ;
    p->id = k ; p->common = &c ;
    create_thread(&th[k],runner,p) ;
  }

  for (int k = 0 ; k < n ; k++) {
    (void)join_thread(&th[k]) ;
  }
  free_my_barrier(c.b) ;
}


void usage(char *pgm) {
  fprintf(stderr,"Usage: %s [-v]* [n] [m]\n",pgm) ;
}

int main(int argc, char **argv) {
  char * pgm = argv[0] ;
  int n = 2 ;
  int m = 10 ;

  ++argv ;
  --argc ;
  while (argc > 0) {
    char *arg = *argv ;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'v') verbose++ ;
      else usage(pgm) ;
    } else {
      break ;
    }
    ++argv;
    --argc ;
  }
  if (argc == 1) {    
    n = atoi(argv[0]) ;
  } else if (argc > 1) {
    n = atoi(argv[0]) ;
    m = atoi(argv[1]) ;
  }  
  run(n,m) ;
  return 0 ;
}
